# Slides API with AI Anchor
**Convert google slides to AI anchor video.**

* Use **slide title** as the video title.
* Use **slide** as the picture in the video.
* Take **notes** as lecture notes.
  * Note: If you want to use **sub_titles** in the English version API, add **[sub_title]** in notes and add the content you want to enter after it, as shown in the figure below.
  
  ![](https://i.imgur.com/QAtrxy8.png)
* Currently only **Peggy** is selected as the anchor.



## Install
```bash
pip install -r requirements.txt
```
Note: See [requirements.txt](requirements.txt) for more details.

## Usage
### Step 1

Create a google slide to be converted into a video.

### Step 2

Add or share permissions to **service@dstest-1-292707.iam.gserviceaccount.com** or set the access permission to **public**.

### Step 3

Find the **presentation id** in the address bar and execute the following command.
```bash
python slides_API_AI_anchor.py --presentation_id {presentation_id} --save_to_local True --eng False
```

* `--presentation_id` *(string, required)* – Choose which slide to convert to video.
* `--save_to_local` *(bool, optional)* – Save the memo locally. If `True`, the img and memo file will be saved in a folder named as the title of the slide. (Default: `True`)
* `--eng` *(bool, optional)* – Choose to use the English version. (Default: `False`)

Note: presentation id ![](https://i.imgur.com/3ew0aZF.png)